unit Unit1;

{$mode objfpc}{$H+}

interface

uses
    Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls, Spin,
    ComCtrls, FileCtrl, Buttons, IniPropStorage, synaser, Pascal_Modbus_RTU, dateutils,
    blcksock, synsock;

type

    { TTimerThread }

    TTimerThread = class(TThread)
    private
        //fStatusText: Word;
        procedure Timer;
    protected
        procedure Execute; override;
    public
        constructor Create(CreateSuspended: boolean);
    end;

    { TForm1 }

    TForm1 = class(TForm)
        btnRead: TButton;
        btnComPorts: TButton;
        btnConnect: TButton;
        btnStop: TButton;
        btnSet: TButton;
        btnDisconnect: TButton;
        CheckCOMHardFlow: TCheckBox;
        CheckCOMSoftFlow: TCheckBox;
        CheckWordWrap: TCheckBox;
        ComboParity: TComboBox;
        editCOM: TEdit;
        FileListBox1: TFileListBox;
        IniPropStorage1: TIniPropStorage;
        Label1: TLabel;
        Label10: TLabel;
        Label11: TLabel;
        Label12: TLabel;
        Label13: TLabel;
        Label14: TLabel;
        Label15: TLabel;
        Label16: TLabel;
        Label2: TLabel;
        Label3: TLabel;
        Label4: TLabel;
        Label5: TLabel;
        Label6: TLabel;
        Label7: TLabel;
        Label8: TLabel;
        Label9: TLabel;
        Memo2: TMemo;
        MemoComment: TMemo;
        RadioGroup_SaveRestore: TRadioGroup;
        SpeedButton1: TSpeedButton;
        SpinCount: TSpinEdit;
        SpinBaudRate: TSpinEdit;
        SpinBits: TSpinEdit;
        SpinMaxErrors: TSpinEdit;
        spinTimeToSleepRx: TSpinEdit;
        spinTimeOut: TSpinEdit;
        SpinStopBits: TSpinEdit;
        SpinFirstReg: TSpinEdit;
        SpinStation: TSpinEdit;
        spinResponceBreackTime: TSpinEdit;
        StatusBar1: TStatusBar;
        Timer1: TTimer;
        procedure btnDisconnectClick(Sender: TObject);
        procedure btnReadClick(Sender: TObject);
        procedure btnSetClick(Sender: TObject);
        procedure btnStopClick(Sender: TObject);
        procedure btnComPortsClick(Sender: TObject);
        procedure btnConnectClick(Sender: TObject);
        procedure CheckWordWrapChange(Sender: TObject);
        procedure FileListBox1SelectionChange(Sender: TObject; User: boolean);
        procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
        procedure FormCreate(Sender: TObject);
        procedure FormShow(Sender: TObject);
        procedure SpeedButton1Click(Sender: TObject);
        procedure Timer1Timer(Sender: TObject);
    private
        { private declarations }
    public
        { public declarations }
        procedure MBrrr(Station: byte; FunctionCode: byte; StartAddress: word;
            CountSended: word; size_mb: cardinal; DataStream: TmemoryStream; NotMatch: boolean);
        procedure ListenError(ErrNum: byte; Data: TmemoryStream);
        procedure ResponceError(Station: byte; ErrorCode, ExceptionCode: byte);
        procedure DiagStr(str: string);
    end;



var
    Form1: TForm1;
    MbCom1: TPascal_Modbus_RTU;
    commm: TBlockSerial;
    ssock: TTCPBlockSocket;
    stop: boolean = True;

    ms: TMemoryStream;
    loadMS: TMemoryStream;
    error: boolean = False;
    ErrorCount: integer = 0;
    StartReg: word = 0;
    cycles: word = 0;
    StopedByButton: boolean = False;
    RegCount: word = 0;
    InProgress: boolean = False;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.MBrrr(Station: byte; FunctionCode: byte; StartAddress: word;
    CountSended: word; size_mb: cardinal; DataStream: TmemoryStream; NotMatch: boolean);
var
    i: integer;
    tmpByte: byte;
    s: string;
    b: byte;
begin
    if StopedByButton then
    begin
        stop := True;
        StatusBar1.SimpleText := 'Stoped by user';
        StopedByButton := False;

        if assigned(ms) then
            FreeAndNil(ms);
        exit;
    end;

    s := '';

    if assigned(DataStream) then
        begin
            DataStream.Position := 0;
            s := IntToStr(DataStream.Size) + ':  ';
            for i := 1 to DataStream.Size do
            begin
                b := DataStream.ReadByte;
                s := s + IntTohex(b,2) + ' ';
            end;
            Memo2.Append(s);
        end;

    if  (DataStream.Size mod 2) = 1 then
    begin
        inc(ErrorCount);
        stop := false;
        exit;
    end;

    ErrorCount := 0;
    if (not Assigned(ms)) and (RadioGroup_SaveRestore.ItemIndex = 0) then
        exit;

    if (StartAddress = StartReg) and (RadioGroup_SaveRestore.ItemIndex = 0) then
    begin
        //swap bytes
        DataStream.Position := 0;
        for i := 1 to (DataStream.Size div 2) do
        begin
            tmpByte := DataStream.ReadByte;
            ms.WriteByte(DataStream.ReadByte);
            ms.WriteByte(tmpByte);
        end;
    end;

    if RadioGroup_SaveRestore.ItemIndex = 1 then
        sleep(1);

    if (cycles < 1) and (RadioGroup_SaveRestore.ItemIndex = 0) then
    begin
        try
            ms.WriteAnsiString(MemoComment.Text);
            ms.Position := 0;
            ms.SaveToFile(FormatDateTime('YYYY-MM-DD hh-nn-ss', now) + '.msr');
            FreeAndNil(ms);
            FileListBox1.UpdateFileList;
        except
            on E: Exception do
                memo2.Append('Write file error ' +
                    FormatDateTime('YYYY-MM-DD hh-nn-ss', now) +
                    '.msr' + ' : ' + AnsiToUtf8(e.Message));
        end;
        //exit;
    end;

    if cycles = 1 then
    begin
        if (SpinCount.Value mod 120) = 0 then
            RegCount := 120
        else
            RegCount := (SpinCount.Value mod 120);
        Inc(StartReg, 120);
        stop := False;
    end;
    if cycles > 1 then
    begin
        Inc(StartReg, 120);
        stop := False;
    end;

    StatusBar1.SimpleText := 'Processed registers: ' + IntToStr(StartReg - SpinFirstReg.Value) +
        '/' + IntToStr(SpinCount.Value);

    if (cycles < 1) then
    begin
        StatusBar1.SimpleText := 'Finished';
        InProgress := False;
        RadioGroup_SaveRestore.Enabled := True;
        btnRead.Enabled := True;
        SpinStation.Enabled := True;
        SpinFirstReg.Enabled := True;
        SpinCount.Enabled := True;
    end;

    if cycles > 0 then
        Dec(cycles);

    FreeAndNil(DataStream);
    Application.ProcessMessages;
end;

procedure TForm1.ListenError(ErrNum: byte; Data: TmemoryStream);
var
    s: string;
    b: byte;
    i: integer;
begin
    if ErrorCount >= SpinMaxErrors.Value then
    begin
        if assigned(ms) then
            FreeAndNil(ms);
        StatusBar1.SimpleText := 'Stoped after many errors';
        InProgress := False;
        RadioGroup_SaveRestore.Enabled := True;
        btnRead.Enabled := True;
        SpinStation.Enabled := True;
        SpinFirstReg.Enabled := True;
        SpinCount.Enabled := True;
    end;
    Inc(ErrorCount);
    Memo2.Append('Line listening error: ' + IntToStr(ErrNum));

    if assigned(Data) then
        begin
            s := IntToStr(data.Size) + ':  ';
            for i := 1 to Data.Size do
            begin
                b := Data.ReadByte;
                s := s + IntTohex(b, 2) + ' ';
            end;
            Memo2.Append(s);
        end;
    FreeAndNil(Data);
    //sleep(35);
    stop := False;
    Application.ProcessMessages;
end;

procedure TForm1.ResponceError(Station: byte; ErrorCode, ExceptionCode: byte);
begin
    Memo2.Append('The responce is error: ' + IntToStr(ErrorCode) + ' ' + IntToStr(ExceptionCode));
    if ErrorCount >= SpinMaxErrors.Value then
    begin
        if assigned(ms) then
            FreeAndNil(ms);
        StatusBar1.SimpleText := 'Stoped after many errors';
        InProgress := False;
        RadioGroup_SaveRestore.Enabled := True;
        btnRead.Enabled := True;
        SpinStation.Enabled := True;
        SpinFirstReg.Enabled := True;
        SpinCount.Enabled := True;
    end;
    Inc(ErrorCount);
    stop := False;
end;

procedure TForm1.DiagStr(str: string);
begin
    Memo2.Append('Diag:  ' + str);
end;

procedure TForm1.btnComPortsClick(Sender: TObject);
begin
    Memo2.Append(synaser.GetSerialPortNames);
end;

procedure TForm1.btnReadClick(Sender: TObject);
var
    TempWord: word;
    DataMs: TMemoryStream;
    i: integer;
    tmpByte: byte;
begin
    stop := True;
    ErrorCount := 0;
    StopedByButton := False;
    if not Assigned(MbCom1) then
        exit;
    InProgress := True;
    RadioGroup_SaveRestore.Enabled := False;
    btnRead.Enabled := False;
    SpinStation.Enabled := False;
    SpinFirstReg.Enabled := False;
    SpinCount.Enabled := False;

    ms := TMemoryStream.Create;
    error := False;
    TempWord := SpinFirstReg.Value;
    ms.Write(TempWord, 2);
    TempWord := SpinCount.Value;
    ms.Write(TempWord, 2);

    cycles := SpinCount.Value div 120;
    StartReg := SpinFirstReg.Value;
    if (SpinCount.Value mod 120) <> 0 then
        Inc(cycles);

    if SpinCount.Value < 121 then
        RegCount := SpinCount.Value
    else
        RegCount := 120;

    Dec(cycles);

    if RadioGroup_SaveRestore.ItemIndex = 0 then
        MbCom1.Read(SpinStation.Value, 3, StartReg, RegCount)
    else
    begin
        if (not Assigned(loadMS)) then
        begin
            memo2.Append('File stream error');
            StatusBar1.SimpleText := 'Finished';
            InProgress := False;
            RadioGroup_SaveRestore.Enabled := True;
            btnRead.Enabled := True;
            SpinStation.Enabled := True;
            SpinFirstReg.Enabled := True;
            SpinCount.Enabled := True;
            if Assigned(loadMS) then
                FreeAndNil(loadMS);
            exit;
        end;
        try
            DataMs := TMemoryStream.Create;
            loadMS.Position := 4;
            for i := 1 to RegCount do
            begin
                tmpByte := loadMS.ReadByte;
                DataMs.WriteByte(loadMS.ReadByte);
                DataMs.WriteByte(tmpByte);
            end;

            MbCom1.Write(SpinStation.Value, 16, StartReg, RegCount, DataMs);

        except
            on e: Exception do
                memo2.Append('File stream reading error ' + e.Message);
        end;
    end;

end;

procedure TForm1.btnDisconnectClick(Sender: TObject);
begin
    if not assigned(MbCom1) then
        exit;
    stop := True;
    MbCom1.DisconnectCom;
    sleep(300);
    FreeAndNil(MbCom1);
    StatusBar1.SimpleText := 'Disconnected';
    InProgress := False;
    RadioGroup_SaveRestore.Enabled := True;
    btnRead.Enabled := False;
    SpinStation.Enabled := True;
    SpinFirstReg.Enabled := True;
    SpinCount.Enabled := True;
    btnConnect.Enabled := True;
    btnStop.Enabled := False;
    btnSet.Enabled := false;
end;

procedure TForm1.btnSetClick(Sender: TObject);
begin
    if not Assigned(MbCom1) then
        exit;
    MbCom1.TimeOutResponce := spinTimeOut.Value;
    MbCom1.TimeToSleepRx := spinTimeToSleepRx.Value;
    MbCom1.ResponceBreakTime := spinResponceBreackTime.Value;
end;

procedure TForm1.btnStopClick(Sender: TObject);
begin
    StopedByButton := True;
    stop := True;
    InProgress := False;
    RadioGroup_SaveRestore.Enabled := True;
    btnRead.Enabled := True;
    SpinStation.Enabled := True;
    SpinFirstReg.Enabled := True;
    SpinCount.Enabled := True;
    StatusBar1.SimpleText := 'Stoped by user';

    if assigned(ms) then
        FreeAndNil(ms);
    exit;
end;


procedure TForm1.btnConnectClick(Sender: TObject);
var
    i: integer;
begin
    if not Assigned(MbCom1) then
    begin
        MbCom1 := TPascal_Modbus_RTU.Create;
        i := MbCom1.ConnectCOM(editCOM.Text);
        if i <> 0 then
        begin
            StatusBar1.SimpleText :=
                'Connection error ' + IntToStr(i) + ': ' + AnsiToUtf8(MbCom1.LastErrorDesc);
            FreeAndNil(mbcom1);
            exit;
        end;
        StatusBar1.SimpleText := 'Connected';
        sleep(20);
        MbCom1.ConfigCOM(SpinBaudRate.Value, SpinBits.Value, ComboParity.Text[1],
            SpinStopBits.Value,
            CheckCOMSoftFlow.Checked, CheckCOMHardFlow.Checked);
        MbCom1.ResponceReadProcedure := @form1.MBrrr;
        MbCom1.ListenError := @form1.ListenError;
        MbCom1.ResponceError := @form1.ResponceError;
        MbCom1.DiagStr := @form1.DiagStr;
        InProgress := False;
        RadioGroup_SaveRestore.Enabled := True;
        if RadioGroup_SaveRestore.ItemIndex = 0 then
            btnRead.Enabled := True
        else
            btnRead.Enabled := false;
        SpinStation.Enabled := True;
        SpinFirstReg.Enabled := True;
        SpinCount.Enabled := True;
        btnConnect.Enabled := False;
        btnStop.Enabled := True;
        btnSet.Enabled := true;
    end;
end;

procedure TForm1.CheckWordWrapChange(Sender: TObject);
begin
    MemoComment.WordWrap := CheckWordWrap.Checked;
end;

procedure TForm1.FileListBox1SelectionChange(Sender: TObject; User: boolean);
begin
    if RadioGroup_SaveRestore.ItemIndex = 0 then
        exit;
    if FileListBox1.ItemIndex < 0 then
        exit;
    if Assigned(loadMS) then
        FreeAndNil(loadms);
    loadms := TMemoryStream.Create;
    btnRead.Enabled := true;
    try
        LoadMS.LoadFromFile(Utf8ToAnsi(FileListBox1.Items.Strings[FileListBox1.ItemIndex]));
        SpinFirstReg.Value := LoadMS.ReadWord;
        SpinCount.Value := LoadMS.ReadWord;
        if LoadMS.Size < 4 then
        begin
            StatusBar1.SimpleText := 'File size in less then 4 bites! ' +
                FileListBox1.Items.Strings[FileListBox1.ItemIndex];
            FreeAndNil(loadms);
            btnRead.Enabled := False;
            exit;
        end;
        if LoadMS.Size < (SpinCount.Value * 2 + 4) then
        begin
            StatusBar1.SimpleText := 'Read file error! (file size is less then registers count) ' +
                FileListBox1.Items.Strings[FileListBox1.ItemIndex];
            FreeAndNil(loadms);
            btnRead.Enabled := False;
            exit;
        end;
        LoadMS.Position := SpinCount.Value * 2 + 4;
        if LoadMS.Position = LoadMS.Size then
            MemoComment.Text := ''
        else
            MemoComment.Text := LoadMS.ReadAnsiString;

        StatusBar1.SimpleText := 'File ready to restore';
    except
        FreeAndNil(loadms);
        btnRead.Enabled := False;
        StatusBar1.SimpleText := 'File read error! ' +
            FileListBox1.Items.Strings[FileListBox1.ItemIndex];
    end;
end;

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
    timer1.Enabled := False;
    sleep(10);
    Application.ProcessMessages;
    sleep(10);
    Application.ProcessMessages;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
    TimerThread: TTimerThread;
begin
    TimerThread := TTimerThread.Create(True);
    if Assigned(TimerThread.FatalException) then
        raise TimerThread.FatalException;
    TimerThread.Start;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
    Timer1.Enabled := True;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
    FileListBox1.UpdateFileList;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
    i: integer;
    DataMs: TMemoryStream;
    tmpByte: byte;
    mbResult: cardinal;
begin
    if stop then
        exit;
    if not Assigned(MbCom1) then
        exit;
    if not InProgress then
        exit;
    if MbCom1.TimeBeforeSend <> 0 then
        exit;
    if MbCom1.SilenceCount < 5 then
        exit;
    if RadioGroup_SaveRestore.ItemIndex = 0 then
        mbResult := MbCom1.Read(SpinStation.Value, 3, StartReg, RegCount)
    else
    begin
        if (not Assigned(loadMS)) then
        begin
            memo2.Append('File stream error');
            StatusBar1.SimpleText := 'Finished';
            InProgress := False;
            RadioGroup_SaveRestore.Enabled := True;
            btnRead.Enabled := True;
            SpinStation.Enabled := True;
            SpinFirstReg.Enabled := True;
            SpinCount.Enabled := True;
            if Assigned(loadMS) then
                FreeAndNil(loadMS);
            exit;
        end;
        DataMs := TMemoryStream.Create;
        for i := 1 to RegCount do
        begin
                tmpByte := loadMS.ReadByte;
                DataMs.WriteByte(loadMS.ReadByte);
                DataMs.WriteByte(tmpByte);
        end;
        mbResult := MbCom1.Write(SpinStation.Value, 16, StartReg, RegCount, DataMs);
    end;
    if mbResult <> 0 then exit;
    stop := True;
    memo2.Append('request: ' + inttostr(StartReg));

end;


{ TTimerThread }

procedure TTimerThread.timer;
begin
    if not Assigned(MbCom1) then
        exit;
    Form1.Label6.Caption := IntToStr(MbCom1.SilenceCount);
    Form1.Label16.Caption := IntToStr(MbCom1.TimeBeforeSend);
end;

procedure TTimerThread.Execute;
begin
    while (not Terminated) do
    begin
        sleep(1);
        Synchronize(@Timer);
    end;
end;

constructor TTimerThread.Create(CreateSuspended: boolean);
begin
    FreeOnTerminate := True;
    inherited Create(CreateSuspended);
end;

end.
